clear; close all; clc;
load concdepth_20180516_BMP4_psmad15.mat;
concs0516 = concs;
timeS0516 = timeS;
edgeDepth0516 = edgeDepth;
edgeDepthCI0516 = edgeDepthCI;

load('../BMP4-sox2-psmad15-20x-20180424/concdepth_20180424_BMP4_psmad15.mat');
concs0424 = concs;
timeS0424 = timeS;
edgeDepth0424 = edgeDepth;
edgeDepthCI0424 = edgeDepthCI;

[~,tedgemax] = max(edgeDepth,[],2);

allconcs = unique([concs0424,concs0516]);
edgeDepthmax = zeros(1,length(allconcs));
edgeDepthmaxCI = zeros(2,length(allconcs));
timemax = zeros(1,length(allconcs));


% for c = 1:length(allconcs)
%     i = find(concs0424==allconcs(c));
%     j = find(concs0516==allconcs(c));
%     
%     if isempty(i)
%         [edgeDepthmax(c),k] = max(edgeDepth0516(j,:));
%         edgeDepthmaxCI(:,c) = edgeDepthCI0516(:,j,k);
%         timemax(c) = timeS0516(k);
%     elseif isempty(j)
%         [edgeDepthmax(c),k] = max(edgeDepth0424(i,:));
%         edgeDepthmaxCI(:,c) = edgeDepthCI0424(:,i,k);
%         timemax(c) = timeS0424(k)./60;
%     else
%         [edgeDepthmax(c),k] = max([edgeDepth0424(i,:) edgeDepth0516(j,:)]);
%         l = length(edgeDepth0424(i,:));
%         if k<=l
%             edgeDepthmaxCI(:,c) = edgeDepthCI0424(:,i,k);
%             timemax(c) = timeS0424(k)./60;
%         else
%             edgeDepthmaxCI(:,c) = edgeDepthCI0516(:,j,k-l);
%             timemax(c) = timeS0516(k-l);
%         end
%     end
% end

for c = 1:length(allconcs)
    i = find(concs0424==allconcs(c));
    j = find(concs0516==allconcs(c));
    
    if ismember(allconcs(c),concs0424)
        [edgeDepthmax(c),k] = max(edgeDepth0424(i,:));
        edgeDepthmaxCI(:,c) = edgeDepthCI0424(:,i,k);
        timemax(c) = timeS0424(k)./60;        
    else
        [edgeDepthmax(c),k] = max(edgeDepth0516(j,:));
        edgeDepthmaxCI(:,c) = edgeDepthCI0516(:,j,k);
        timemax(c) = timeS0516(k);
    end
end

edgeDepthmax = 1+0.65./13.*edgeDepthmax;
edgeDepthmaxCI = 1+0.65./13.*edgeDepthmaxCI;


figure; hold on;
for c = 1:length(allconcs)
    errorbar(allconcs(c), edgeDepthmax(c),...
    abs((edgeDepthmaxCI(2,c))-edgeDepthmax(c)),...
    abs((edgeDepthmaxCI(1,c))-edgeDepthmax(c)),'ko','LineWidth',2);
end
xlabel('BMP Concentration');
set(gca,'XScale','log');
xlim([0.25,800]);
ylim([1 12]);
ylabel('pSMAD1/5+ Edge Depth (Cell Lengths)');
set(gca,'FontSize',20);
set(gca,'LineWidth',2);
set(gca,'XTickLabel',[1 10, 100])
%export_fig(strcat('concdepth',num2str(timeS(t)),'min_20180424_BMP4_psmad15.pdf'));
%close;


%% Double Sigmoid Fit
F = @(p,x) p(1)./(1+exp(p(2).*(p(3)-x))) + (p(4)-p(1))./(1+exp(p(5).*(p(6)-x)))+p(7);
p0 = [4 1 5 10 1 50 2];
plb = [0 0 0.5 0 0 1.2 0];
pub = [Inf Inf 1 Inf Inf 2 12];
options= optimoptions('lsqcurvefit','MaxFunctionEvaluations',5000);
[p,resnorm,~,exitflag,output] = lsqcurvefit(F,p0,log10(allconcs'),edgeDepthmax',plb,pub,options);

xF = linspace(0.5,500,10000);
% plot(xF,F(p,log10(xF)),'b-');
export_fig('concdepth_BMP4_psmad15.pdf');