close all; clear; clc; 
set(0,'DefaultAxesFontSize',26);

Iconc = zeros(1024,1024,99);
Iconcscale = zeros(1010,1010,99);
for t = 1:99
    Iconc(:,:,t) = double(imread('C2-uf-40ulhr-20170410-47-s4.tif',t));
    Iconcscale(:,:,t) = double(imread('C2-uf-40ulhr-20170410-47-s4_scale.tif',t));
end
Iconc = Iconc(8:1017,8:1017,:);
xl = 126;
xr = 896;
Iconcmean = mean(Iconc,1);

imwrite(uint16(Iconcscale(:,:,11)),'uf-20170410-47-t0.tiff');
imwrite(uint16(Iconcscale(:,:,41)),'uf-20170410-47-t5.tiff');
imwrite(uint16(Iconcscale(:,:,71)),'uf-20170410-47-t10.tiff');

%%
F = figure; hold on;
set(gcf, 'Color', 'w');
set(gcf, 'Position', get(0, 'Screensize'));
set(gca,'FontSize',58);
set(gca,'LineWidth',3);
%F.Position(3) = F.Position(4)*2/3;
for t = 11:99
    plot((0:(xr-xl))*1.3,Iconcmean(1,xl:xr,t),'Color',[(t-11)./88,0,0],'LineWidth',3);
end
zeroset = plot([0,(xr-xl)*1.3],[min(Iconcmeanmean),min(Iconcmeanmean)],'b--','LineWidth',1);
oneset = plot([0,(xr-xl)*1.3],[max(Iconcmeanmean),max(Iconcmeanmean)],'b--','LineWidth',1);
text(50,800,'c = 0','FontSize',20,'Color','b');
text(850,1875,'c = 1','FontSize',20,'Color','b');
xlim([0,1001]);
ylim([700,2000]);
set(gca,'XMinorTick','on');
set(gca,'YMinorTick','on');
xlabel('Channel Position (m)');
ylabel('Fluorescence Level');
colorbar('Ticks',[0 0.3409 0.6818],'TickLabels',{'0','5', '10'},'LineWidth',3);
rmap = [(0:0.01:1)',zeros(101,1),zeros(101,1)];
colormap(rmap);
h = gcf;
pos = get(h,'Position');
set(h,'PaperPositionMode','Auto','PaperUnits','points','PaperSize',[1440, 900])
print('ufluidicgrad_time.pdf','-dpdf');
close;

%%

Iconcmeanfilt = zeros(size(Iconcmean));
for t = 1:99
    Iconcmeanfilt(:,xl:xr,t) = imgaussfilt(Iconcmean(:,xl:xr,t),5);
end

Iconcmeanmean = mean(Iconcmean(1,xl:xr,11:99),3);
Iconcmeanmean_zero = Iconcmeanmean - min(min(Iconcmeanfilt(1,xl:xr,11:99)));
Iconcmeanmean_zero(Iconcmeanmean_zero<0) = 0;
Iconcmeanstd = std(Iconcmean(1,xl:xr,11:99),0,3);
Iconcmeanrange = range(Iconcmean(1,xl:xr,11:99),3);
Iconcmeannormrange = Iconcmeanrange ./ range(Iconcmean(:));
Iconcmeanmeanfilt = imgaussfilt(Iconcmeanmean,5);

figure; 
set(gcf, 'Color', 'w');
set(gcf, 'Position', get(0, 'Screensize'));
plot((0:xr-xl)*1.3,Iconcmeannormrange,'b-','LineWidth',2);
xlabel('Channel Position (m)');
ylabel('$$\frac{\textrm{Fluorescence Range}}{\textrm{Gradient Range}}$$', 'Interpreter','latex');
xlim([0 1001]);
ylim([0.01 0.06])
set(gca,'YTick',0.01:0.01:0.06);
set(gca,'XMinorTick','on');
set(gca,'YMinorTick','on');
h = gcf;
pos = get(h,'Position');
set(h,'PaperPositionMode','Auto','PaperUnits','points','PaperSize',[1440, 900])
print('ufluidicgrad_range.pdf','-dpdf');
close;

%%
concfit = find(Iconcmeanmean_zero>(0.15.*max(Iconcmeanmean_zero)),1):(find(Iconcmeanmean_zero>(0.95.*max(Iconcmeanmean_zero)),1)-1);
%concfit = find(abs(imgaussfilt(diff(imgaussfilt(diff(Iconcmeanmeanfilt),50)),50))<0.003);
concparam = polyfit(concfit*1.3,Iconcmeanmean(concfit),1);


figure;
set(gcf, 'Color', 'w');
set(gcf, 'Position', get(0, 'Screensize'));
concplot = plot((0:xr-xl)*1.3,Iconcmeanmean,'k','LineWidth',1);
hold on;
zeroset = plot([0,(xr-xl)*1.3],[min(Iconcmeanmean),min(Iconcmeanmean)],'r--','LineWidth',1);
oneset = plot([0,(xr-xl)*1.3],[max(Iconcmeanmean),max(Iconcmeanmean)],'r--','LineWidth',1);
xlim([0,1001]);
ylabel('Fluorescence Level');
xlabel('Channel Position (m)');
%concfitplot = plot(concfit.*1.3, concparam(1).*concfit.*1.3 + concparam(2),'b-','LineWidth', 1);
%plot([concfit(1).*1.3;concfit(1).*1.3],[min(Iconcmeanmean);max(Iconcmeanmean)],'k-.');
%plot([concfit(end).*1.3;concfit(end).*1.3],[min(Iconcmeanmean);max(Iconcmeanmean)],'k-.');
cresidual = Iconcmeanmean(concfit)-(concparam(1).*(concfit).*1.3 + concparam(2));
ctotal = sum((Iconcmeanmean(concfit) - mean(Iconcmeanmean(concfit))).^2);
Rsq = 1-sum(cresidual.^2)/ctotal;
% legend([concplot,concfitplot],'Mean Fluorescein Intensity','Linear Fit', 'Location','east'); 
% text(600,1600,'R^2 = 0.999','FontSize',26);
text(50,800,'c = 0','FontSize',20,'Color','r');
text(850,1875,'c = 1','FontSize',20,'Color','r');
% text(250,1950,'c = 0.15','FontSize',14,'Color','k');
% text(910,1950,'c = 0.95','FontSize',14,'Color','k');
h = gcf;
pos = get(h,'Position');
set(h,'PaperPositionMode','Auto','PaperUnits','points','PaperSize',[1440, 900])
print('ufluidicgrad_fit.pdf','-dpdf');
close;
